<?php
/**
 * Clase Base FN para BaseCrCierrehipotecaDFN
 *
 * @package    
 * @subpackage BaseCrCierrehipotecaDFN
 * @author     Willy
 * @version    SVN:: BaseCrCierrehipotecaDFN.class.php,v 1.1 2013-02-06 11:52:07 william.taype Exp $
 */
class BaseCrCierrehipotecaDFN extends CrCierrehipotecaDBN
{
  private static $fieldNames = array (
    'Idcierred'=>'idcierred', 'Idcolaborador'=>'idcolaborador', 'Nombrecolaborador'=>'nombrecolaborador', 'Ingresototal'=>'ingresototal', 'Salidatotal'=>'salidatotal', 'Saldototal'=>'saldototal', 'Fecharegistro'=>'fecharegistro', 'Usaurioregistro'=>'usaurioregistro', 'Idsucursal'=>'idsucursal', 'Fecha'=>'fecha'  
  );

  public function select()
  {
    try
    {
      $tamPag = !property_exists($this, 'tamPag')?9999:$this->tamPag;
      $pagina = !property_exists($this, 'page')||$this->page==""?1:$this->page;
      $numeroRegistros = $this->selectNumRows();
      $limitInf = ($pagina-1)*$tamPag;

      $where = $this->buildConsult();
      $orden = $this->buildOrderByField();

      $con = Conexion::getConexion();
      $sql = "SELECT idcierred,moneda, idcolaborador, nombrecolaborador, ingresototal, ingresototaldeposito, salidatotal,ingresototalpi, salidatotalpi, saldototal, fecharegistro, usaurioregistro, idsucursal, fecha FROM cr_cierrehipoteca_d WHERE 1 ".$where." ".$orden."  LIMIT ".$limitInf.",".$tamPag;
       //echo $sql;
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $num_rows = mysql_num_rows($result);
      $a_tmp = array();
      if($num_rows>0){
        while ($o_valor = mysql_fetch_object($result)) {
          $a_tmp[] = $this->insertObjectBN($o_valor);
        }
      }
      
      return count($a_tmp)>0?$a_tmp:null;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function selectNumRows()
  {
    try
    {
      $where = $this->buildConsult();

      $con = Conexion::getConexion();
      $sql = "SELECT idcierred, idcolaborador, nombrecolaborador, ingresototal, salidatotal, saldototal, fecharegistro, usaurioregistro, idsucursal, fecha FROM cr_cierrehipoteca_d WHERE 1 ".$where;
      //echo $sql;
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $num_rows = mysql_num_rows($result);
      
      return $num_rows;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildConsult()
  {
    try
    {
      $where = "";

      if($this->getIdcierred()){ $where .= " AND idcierred = '".$this->getIdcierred()."'"; }
      if($this->getIdcolaborador()){ $where .= " AND idcolaborador = '".$this->getIdcolaborador()."'"; }
      if($this->getNombrecolaborador()){ $where .= " AND nombrecolaborador = '".$this->getNombrecolaborador()."'"; }
      if($this->getIngresototal()){ $where .= " AND ingresototal = '".$this->getIngresototal()."'"; }
      if($this->getMoneda()){ $where .= " AND moneda = '".$this->getMoneda()."'"; }
      if($this->getSalidatotal()){ $where .= " AND salidatotal = '".$this->getSalidatotal()."'"; }
      if($this->getSaldototal()){ $where .= " AND saldototal = '".$this->getSaldototal()."'"; }
      if($this->getFecharegistro()){ $where .= " AND fecharegistro = '".$this->getFecharegistro()."'"; }
      if($this->getUsaurioregistro()){ $where .= " AND usaurioregistro = '".$this->getUsaurioregistro()."'"; }
      if($this->getIdsucursal()){ $where .= " AND idsucursal = '".$this->getIdsucursal()."'"; }
      if($this->getFecha()){ $where .= " AND fecha = '".$this->getFecha()."'"; }
      return $where;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildOrderByField()
  {
    try
    {
      $order_by = "";

      if(property_exists($this,'sortCampos')){
      if($this->sortCampos != ""){
        $a_valCampos = explode(";", $this->sortCampos);
        $a_valtype   = explode(";", $this->sortType);
        $order_by = " ORDER BY ";
        $a_order = array();
        foreach ($a_valCampos as $key => $val){
          $sTmpOrder = "";
          if(array_key_exists($val, self::$fieldNames)){
            $sTmpOrder .= self::$fieldNames[$val];
            switch ($a_valtype[$key]){
              case 1: $sTmpOrder .= " ASC"; break;
              case 2: $sTmpOrder .= " DESC"; break;
            }
            $a_order[] = $sTmpOrder;
          }
        }
        $order_by .= implode(", ", $a_order);
      }
      }
      return $order_by;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* B�squeda del registro por la llave primaria */
  public function selectByPK()
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT idcierred, moneda,idcolaborador, nombrecolaborador, ingresototal, salidatotal,ingresototalpi, salidatotalpi, saldototal, fecharegistro, usaurioregistro, idsucursal, fecha FROM cr_cierrehipoteca_d WHERE 1 AND idcierred='".$this->getIdcierred()."'; ";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $o_Propel = $result ? mysql_fetch_object($result) : null;
      

      return $o_Propel?$this->insertObjectBN($o_Propel):null;

    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Devuelve un objeto con m�todos de acceso */
  private function insertObjectBN($o_propel){
    $o_BaseCrCierrehipotecaDFN = new BaseCrCierrehipotecaDFN();
    $o_BaseCrCierrehipotecaDFN->setIdcierred($o_propel->idcierred);
    $o_BaseCrCierrehipotecaDFN->setMoneda($o_propel->moneda);
    $o_BaseCrCierrehipotecaDFN->setIdcolaborador($o_propel->idcolaborador);
    $o_BaseCrCierrehipotecaDFN->setNombrecolaborador($o_propel->nombrecolaborador);
    $o_BaseCrCierrehipotecaDFN->setIngresototal($o_propel->ingresototal);
    $o_BaseCrCierrehipotecaDFN->setIngresototalDeposito($o_propel->ingresototaldeposito);
    $o_BaseCrCierrehipotecaDFN->setIngresototalPI($o_propel->ingresototalpi);
    $o_BaseCrCierrehipotecaDFN->setSalidatotal($o_propel->salidatotal);
    $o_BaseCrCierrehipotecaDFN->setSalidatotalPI($o_propel->salidatotalpi);
    $o_BaseCrCierrehipotecaDFN->setSaldototal($o_propel->saldototal);
    $o_BaseCrCierrehipotecaDFN->setFecharegistro($o_propel->fecharegistro);
    $o_BaseCrCierrehipotecaDFN->setUsaurioregistro($o_propel->usaurioregistro);
    $o_BaseCrCierrehipotecaDFN->setIdsucursal($o_propel->idsucursal);
    $o_BaseCrCierrehipotecaDFN->setFecha($o_propel->fecha);
    return $o_BaseCrCierrehipotecaDFN;
  }
}